/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: PlottUnit.cpp                                          */
/*                                                                       */
/*  Revision: V1.1     Date: 01.05.2007    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Plott utility linear, logarithmic and 3D                    */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 01.05.2007
// Updated by: Chr. Monstein 01.05.2007
//---------------------------------------------------------------------------
#pragma hdrstop

#include <math.h>
#include <stdio.h>
#include "dislin.h"
#include "PlottUnit.h"
#include "MyGlobal.h"
#include "plottlc.h"
#include "plottlc.h"
extern float PlotWidthFact;
extern float PlotHeigthFact;
int win_x0, win_y0;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TPlotter::TPlotter() // constructor
{
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::Init(void) // Farben, Groesse, evtl. Position
{
    title_text       = new char[bufferwidth];
    filename         = new char[bufferwidth];
    xlabel_text      = new char[bufferwidth];
    ylabel_text      = new char[bufferwidth];
    xarr             = new float[MaxRows];
    yarr1            = new float[MaxRows];
    yarr2            = new float[MaxRows];
    yarr3            = new float[MaxRows];
    device           = new char[bufferwidth];
    win_width        = (Screen->DesktopWidth/PlotWidthFact); //848;
    win_height       = (Screen->DesktopWidth/PlotHeigthFact); //600;
    win_x0           = win_x0;//Screen->DesktopWidth-win_width;//800;
    win_y0           = win_y0; //Screen->DesktopHeight-win_height;//0;
    character_height = 50;//60;
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetNumber(long _n) {Ni = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetTitle(char *_text) {sprintf(title_text, _text);}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetFileName(char *_text) {sprintf(filename, _text);}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetDevice(char *_dev) {sprintf(device, _dev);}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXLabel(char *_text) {sprintf(xlabel_text, _text);}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXminmax(float _a, float _b, float _c)
                {xmin=_a; xmax=_b; dx=_c;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYminmax(float _a, float _b, float _c)
                {ymin=_a; ymax=_b; dy=_c;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYLabel(char *_text) {sprintf(ylabel_text, _text);}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXvector(float *_x) {xarr = _x;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector1(float *_y) {yarr1 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector2(float *_y) {yarr2 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector3(float *_y) {yarr3 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetThickness_Curve(int _n) {thick_curve = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetMarker(int _n) {mark = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetThickness_Marker(int _n) {thick_mark = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::LinPlott(int resample) // lin
{
    metafl(device); // XWIN or CONS or PDF
    window(win_x0,win_y0,win_width,win_height); // Fensterposition und -groesse in pixel x0, y0,w,h
    setfil (filename);
    filmod ("DELETE");
    disini(); // oeffnet fenster
    winmod("NONE"); // FULL, NONE (muss nicht quittiert werden), NOHOLD, NOERASE (blitzt nicht aber blockiert main), DELAY
    errmod("ALL","OFF");
    //setpag("DA6P");
    pagera(); // small border around the page

    if ((strstr("XWIN",device)) || (strstr("PNG",device)))
       backgroundcolor=255;   //0(in PDF, EPS und PNG weiss),255(=> schwarz)
    else
       backgroundcolor=0;

    pagfll(backgroundcolor); // hintergrundfarbcode

    hwfont();  // Font
    height(character_height); // character height in pixels
    paghdr("ETHZ","Callisto",1,1); // Randbeschriftung
    axspos(350,1800);       // position im Fenster
    axslen(2200,1600);      // Breite, Hhe =2/3 of page
    name(xlabel_text,"x");  // X-Label
    name(ylabel_text,"y");  // Y-label
    titlin(title_text,4);

    if ((strstr("XWIN",device)) || (strstr("PNG",device)))
       color("black");    // fore, auto, green, white(in PDF, EPS und PNG schwarz)
    else
       color("white");

    labdig(1,"x");        // Format x-axis float, 0=point, n=digits
    axsscl("LIN","y");    // y-Achse linear
    labdig(1,"y");        // nachkommastellen y-Achse
    hname(55);            // schriftgroesse Achsennamen
    labels("FLOAT","y");  // LOG-Format nur y-Label
    thkcrv(thick_curve);  // thickness curve
    //marker(mark);         // marker symbol
    //hsymbl(7*(thick_mark) - 1);   // thickness marker (system uses 6,13,20,...)
    //incmrk(1);            // symbolabstaende in messpunkte

    graf(xmin,xmax,xmin,dx,ymin, ymax, ymin, dy);  // linear variabel
    title();

    //marker(3);
    color("red");
    curve(xarr,yarr1,Ni);  // Lichtkurve1

    //marker(2);
    color("green");
    curve(xarr,yarr2,Ni);  // Lichtkurve2

    //marker(5);
    color("blue");
    curve(xarr,yarr3,Ni);  // Lichtkurve3

    endgrf();
    disfin();
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::Close()
{
   delete [] title_text;
   delete [] filename;
   delete [] xlabel_text;
   delete [] ylabel_text;
   delete [] xarr;
   delete [] yarr1;
   delete [] yarr2;
   delete [] yarr3;
   delete [] device;
}
//---------------------------------------------------------------------------
__fastcall TPlotter::~TPlotter() // destructor
{
}
//---------------------------------------------------------------------------
