/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: PlottUnit.h                                            */
/*                                                                       */
/*  Revision: V1.1     Date: 01.05.2007    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Plott utility linear, logarithmic and 3D                    */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 01.05.2007
// Updated by: Chr. Monstein 01.05.2007
//---------------------------------------------------------------------------
#ifndef PlottUnitH
#define PlottUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TPlotter
{
    private:
        char *title_text;
        char *filename;
        char *xlabel_text;
        char *ylabel_text;
        char *device;
        int win_width, win_height;
        int backgroundcolor;
        int character_height;
        float xmin, xmax, dx;
        float ymin, ymax, dy;
        float *xarr;
        float *yarr1;
        float *yarr2;
        float *yarr3;
        int thick_curve;
        int thick_mark;
        int mark;
        long Ni;
        int Rows, Cols;
        int zmin, zmax;

    protected:


    public:
        __fastcall TPlotter(); // constructor
        void __fastcall SetTitle(char *_text);
        void __fastcall SetFileName(char *_text);
        void __fastcall SetDevice(char *_text);
        void __fastcall SetXLabel(char *_text);
        void __fastcall SetXminmax(float _a, float _b, float _c);
        void __fastcall SetXvector(float *_x);
        void __fastcall SetThickness_Curve(int _n);
        void __fastcall SetMarker(int _n);
        void __fastcall SetThickness_Marker(int _n);
        void __fastcall SetYvector1(float *_y);
        void __fastcall SetYvector2(float *_y);
        void __fastcall SetYvector3(float *_y);
        void __fastcall SetYLabel(char *_text);
        void __fastcall SetYminmax(float _a, float _b, float _c);
        void __fastcall SetNumber(long _n);
        void __fastcall LinPlott(int resample); // lin
        void __fastcall Init(void);
        void __fastcall Close(void);
        __fastcall ~TPlotter(); // destructor
};

//---------------------------------------------------------------------------
#endif
