//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "plottlc.h"
#include "PlottUnit.h"
#include "fileselect.h"
#include "stats.h"
#include <stdio.h>
#include <fstream.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
TPlotter *MyPlott;
extern int win_x0, win_y0;
char st[100]; //temp st fr sprintf
//file
char filename[180];    //Dateiname
char defaultpath[240];  //from config
char outputDir[240];   //from config
char unit[5];          //SFU oder ADU
float fLC1, fLC2, fLC3; //Frequenzen
int counts;            //Datenpunkt (Zeile, 1st=0)
int maxcount;          //Anzahl Zeilen-1
float min_t, max_t;
float min_t_plot, max_t_plot;
float max_y, max_y_display, min_y;
float max_y_1, max_y_2, max_y_3;
float min_y_1, min_y_2, min_y_3;
float last_y_1, last_y_2, last_y_3;
float range1, range2, range3;
float rangemin1, rangemin2, rangemin3;
static float times[MaxRows];
static float lc1[MaxRows];
static float lc2[MaxRows];
static float lc3[MaxRows];
//plot
char plotname[180];    //Dateiname
int Ylow = 0.0;
int Yhigh = 50.0;
int Xlow = 0.0;
int Xhigh = 24.0;
float DWidth=Screen->DesktopWidth;
float DHeight=Screen->DesktopHeight;
bool firstOpen = true;
float PlotWidthFact=2.0;
float PlotHeigthFact=PlotWidthFact*1.414;//2.8;
int PlotMoveStep=Screen->DesktopWidth/200;    //small steps
int DefaultPlotSize; //from config
int DefaultUpdateInterval;//from config

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReadLocalPar(void) //Config einlesen.
{
  char buff[240];
  int j=0;
  char LonCode, LatCode;
  AnsiString st;

  ifstream infile("PlotLC.cfg");
  while (infile)
  {
      infile.getline(buff,240);
      st = LowerCase(AnsiString(buff));
      if (buff[0]=='[')
      {
        if (strstr(st.c_str(),"[path]=")) sscanf(buff,"[path]=%s",&defaultpath);
        if (strstr(st.c_str(),"[output]=")) sscanf(buff,"[output]=%s",&outputDir);
        if (strstr(st.c_str(),"[size]=")) sscanf(buff,"[size]=%i",&DefaultPlotSize);
        if (strstr(st.c_str(),"[update]=")) sscanf(buff,"[update]=%i",&DefaultUpdateInterval);
      }
  }
  infile.close();
  while (j<240)     //replace | with space
  {
     if (defaultpath[j]=='|') defaultpath[j]=' ';
     if (outputDir[j]=='|') outputDir[j]=' ';
     j++;
  }
  //Form2->ComboBox2Change(0);
  //if (DirectoryExists(defaultpath)) Form2->DirectoryListBox1->Directory=defaultpath;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  ReadLC();
  Form3->UpdateStats();
  MyPlott->SetNumber(maxcount);
  MyPlott->SetXvector(times);
  MyPlott->SetYvector1(lc1);
  MyPlott->SetYvector2(lc2);
  MyPlott->SetYvector3(lc3);

  min_t_plot=int(min_t);
  max_t_plot=int(max_t)+1;

  char Title[80];
  char filename[80];
  char extension[5];

  sprintf(Title,"%s:r=%6.2fMHz, g=%6.2fMHz, b=%6.2fMHz",ExtractFileName(Form2->FileListBox1->FileName),fLC1,fLC2,fLC3);
  MyPlott->SetTitle(Title);
  MyPlott->SetXLabel("Time [UT]");
  sprintf(st,"[%s]",unit);
  MyPlott->SetYLabel(unit);

  if (RadioButton2->Checked) sprintf(extension,"PDF");
  if (RadioButton3->Checked) sprintf(extension,"EPS");
  if (RadioButton4->Checked) sprintf(extension,"PNG");

  Ylow=rangemin1;
  Yhigh=range1;

  sprintf(plotname,"%sPlot_%s.%s",ExtractFilePath(outputDir),ExtractFileName(Form2->FileListBox1->FileName),extension);
  MyPlott->SetFileName(plotname);
  MyPlott->SetThickness_Curve(atoi(Edit2->Text.c_str()));
  //MyPlott->SetThickness_Marker(atoi(Edit3->Text.c_str()));
  MyPlott->SetMarker(0);
  MyPlott->SetXminmax(min_t_plot, max_t_plot, ((max_t_plot-min_t_plot)/10));
  MyPlott->SetYminmax(Ylow, Yhigh, ((Yhigh-Ylow)/10));
  MyPlott->SetNumber(maxcount);

  if (RadioButton1->Checked) MyPlott->SetDevice("XWIN");
  if (RadioButton2->Checked) MyPlott->SetDevice("PDF");
  if (RadioButton3->Checked) MyPlott->SetDevice("EPS");
  if (RadioButton4->Checked) MyPlott->SetDevice("PNG");
  //MyPlott->Init();
  MyPlott->LinPlott(1); // resampe = 1
}
//---------------------------------------------------------------------------
//Datei einlesen
void __fastcall TForm1::ReadLC(void)
{
    char buff[180];
    int i=0;
    float a, x, y, z;
    while (i<=MaxRows)
    {
       times[i]=0.0;
       lc1[i]=0.0;
       lc2[i]=0.0;
       lc3[i]=0.0;
       i++;
    }
    sprintf(filename,"%s",Form2->FileListBox1->FileName);
    min_t=24.0;
    max_t=0.0;
    max_y_1=-1000, max_y_2=-1000, max_y_3=-1000;
    min_y_1= 1000, min_y_2= 1000, min_y_3= 1000;
    FILE *in;
    if ((in = fopen(filename, "rt")) == NULL)
    {
        //Application->MessageBox("file does not exist", "Error", MB_OK);
    }
    else
    {
      counts = 0;
      char st[80];
      while (!feof(in))
      {
          fgets(buff,sizeof(buff),in);
          if (strstr(buff,"Time_UT,"))
          {
             sscanf(buff,"Time_UT,%fMHz,%fMHz,%fMHz",&fLC1,&fLC2,&fLC3);
             sprintf(st,"f1=%5.1fMHz",fLC1);
             //Label2->Caption=st;
             sprintf(st,"f2=%5.1fMHz",fLC2);
             //Label3->Caption=st;
             sprintf(st,"f3=%5.1fMHz",fLC3);
             //Label4->Caption=st;
          }
          else
          {
              if (counts>=2)
              {
                  sscanf(buff,"%f,%f,%f,%f",&a,&x,&y,&z);
                  //           01,02,03,04  01,02,03,04
                  times[counts]=a;
                  lc1[counts]=x;
                  lc2[counts]=y;
                  lc3[counts]=z;
                  if (x > max_y_1 && counts > 1) max_y_1= x;
                  if (x < min_y_1 && counts > 1) min_y_1= x;
                  if (y > max_y_2 && counts > 1) max_y_2= y;
                  if (y < min_y_2 && counts > 1) min_y_2= y;
                  if (z > max_y_3 && counts > 1) max_y_3= z;
                  if (z < min_y_3 && counts > 1) min_y_3= z;
                  if (a > max_t)   max_t  = a;   //Min/Max Zeit bestimmen
                  if (a < min_t)   min_t  = a;
              }
          }
          counts++;
      }
      maxcount = counts;                  //Anzahl Zeilen wird bentigt fr Wertsuche
    }
    if (max_y_2 > max_y_1) max_y_1 = max_y_2;
    if (max_y_3 > max_y_1) max_y_1 = max_y_3;
    if (min_y_2 < min_y_1) min_y_1 = min_y_2;
    if (min_y_3 < min_y_1) min_y_1 = min_y_3;
    range1=5*((int(max_y_1/5))+1);
    rangemin1=5*(int(min_y_1/5));
    last_y_1=lc1[maxcount-1];
    last_y_2=lc2[maxcount-1];
    last_y_3=lc3[maxcount-1];
    //sprintf(st,"[min=%5.2fUT; max=%5.2fUT]",min_t,max_t);  //Anzeige Min/Max Zeit
    fclose(in);
}
//-------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Form2->Visible=true;
   Button2->Enabled=false;
   Button1->Enabled=true;
   if (firstOpen==true)
   {
      firstOpen = false;
      Form2->Label2->Caption=defaultpath;
      Form2->Label5->Caption=outputDir;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   if(Timer1->Enabled == true)
   {
      Timer1->Enabled=false;
      sprintf(st,"Run");
      Button3->Caption=st;
   }
   else
   {
      Timer1->Enabled=true;
      sprintf(st,"Stop");
      Button3->Caption=st;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CSpinEdit1Change(TObject *Sender)
{
   Timer1->Interval=1000*(CSpinEdit1->Value);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   Button1Click(0);
   Form3->UpdateStats();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   Form3->Visible=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
    switch (ComboBox1->ItemIndex)
    {
      case 0: //XS
      {
          PlotWidthFact=4.0;
          PlotHeigthFact=1.414*PlotWidthFact;   //(DWidth/DHeight)*PlotWidthFact;
      }
      break;
      case 1: //S
      {
          PlotWidthFact=3.0;
          PlotHeigthFact=1.414*PlotWidthFact; //4.2;
      }
      break;
      case 2: //M
      {
          PlotWidthFact=2.0;
          PlotHeigthFact=1.414*PlotWidthFact; //2.8;
      }
      break;
      case 3: //L
      {
          PlotWidthFact=1.0;
          PlotHeigthFact=1.414*PlotWidthFact; //1.4;
      }
      break;
      case 4: //XL
      {
          PlotWidthFact=0.5;
          PlotHeigthFact=1.414*PlotWidthFact; //0.7;
      }
      break;
    }
    sprintf(st,"h=%i px",int(Screen->DesktopWidth/PlotHeigthFact));
    Label4->Caption=st;
    sprintf(st,"w=%i px",int(Screen->DesktopWidth/PlotWidthFact));
    Label5->Caption=st;
    MyPlott->Init();
    if (Button1->Enabled==true)  Button1Click(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   Form1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   ReadLocalPar();
   ComboBox1->ItemIndex=DefaultPlotSize;  //Plot Size from local Par
    switch (DefaultPlotSize)
    {
      case 0: //XS     //Init Plot size
      {
          PlotWidthFact=4.0;
          PlotHeigthFact=1.414*PlotWidthFact;   //(DWidth/DHeight)*PlotWidthFact;
      }
      break;
      case 1: //S
      {
          PlotWidthFact=3.0;
          PlotHeigthFact=1.414*PlotWidthFact; //4.2;
      }
      break;
      case 2: //M
      {
          PlotWidthFact=2.0;
          PlotHeigthFact=1.414*PlotWidthFact; //2.8;
      }
      break;
      case 3: //L
      {
          PlotWidthFact=1.0;
          PlotHeigthFact=1.414*PlotWidthFact; //1.4;
      }
      break;
      case 4: //XL
      {
          PlotWidthFact=0.5;
          PlotHeigthFact=1.414*PlotWidthFact; //0.7;
      }
      break;
    }
    sprintf(st,"h=%i px",int(Screen->DesktopWidth/PlotHeigthFact));
    Label4->Caption=st;
    sprintf(st,"w=%i px",int(Screen->DesktopWidth/PlotWidthFact));
    Label5->Caption=st;
   CSpinEdit1->Value=DefaultUpdateInterval; //From Config
   CSpinEdit1Change(0);                      // Init Update Interval
   MyPlott = new TPlotter;
   win_x0 = Screen->DesktopWidth-(Screen->DesktopWidth/PlotWidthFact);
   win_y0 = Screen->DesktopHeight-(Screen->DesktopWidth/PlotHeigthFact);
   MyPlott->Init();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)   //up
{
   if ((win_y0-PlotMoveStep) >= 0) win_y0 = win_y0 -PlotMoveStep;
   else win_y0=0;
   MyPlott->Init();
   Button1Click(0);
   //Screen->DesktopHeight-(Screen->DesktopWidth/PlotHeigthFact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)  //down
{
   if ((win_y0+PlotMoveStep) <= Screen->DesktopHeight-(Screen->DesktopWidth/PlotHeigthFact)) win_y0 = win_y0 +PlotMoveStep;
   else win_y0=Screen->DesktopHeight-(Screen->DesktopWidth/PlotHeigthFact);
   MyPlott->Init();
   Button1Click(0);
   //Screen->DesktopHeight-(Screen->DesktopWidth/PlotHeigthFact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)   //right
{
   if ((win_x0+PlotMoveStep) <= Screen->DesktopWidth-(Screen->DesktopWidth/PlotWidthFact)) win_x0 = win_x0 +PlotMoveStep;
   else win_x0=Screen->DesktopWidth-(Screen->DesktopWidth/PlotWidthFact);
   MyPlott->Init();
   Button1Click(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)   //left
{
   if ((win_x0+PlotMoveStep) >= 0) win_x0 = win_x0 -PlotMoveStep;
   else win_x0=0;
   MyPlott->Init();
   Button1Click(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   if (CheckBox1->Checked)
      PlotMoveStep=Screen->DesktopWidth/20;    //coarse
   else
      PlotMoveStep=Screen->DesktopWidth/200;    //fine
}
//---------------------------------------------------------------------------







